/*
<html>
<head><title>Bookmark Menu Applet Window</title></head>
<body onLoad="document.applets["j1menuApplet"].setTarget(opener.name);">

    <applet code="j1menu.class" name="j1menuApplet"
        height=40 width=80>
        <param name=filename   value="bookmark.htm">
        <param name=target     value="j1menutarget">
    </applet>

    WARNING: Use either parameter 'target' or setTarget() method.
             Don't use both!
</body></html>
 */
import java.applet.*;
import java.awt.event.*;
import java.awt.*;            // for Menu
import java.net.*;            // for URL, MalformedURLException
import java.io.*;             // for InputStream, Reader 

public class j1menu extends Applet 
{
    final PopupMenu m = new PopupMenu();;
    final Button    b = new Button();

    String    target = "j1menu";            // target name of browser window
    String    filename = "bookmark.htm";    // file to read bookmarks from
 
    URL anchor;

    public void init() 
    {
        b.setSize(this.getSize());
        b.setLabel("Loading...");
        add(b);                         // Clicking on this button ...
        add(m);                         // ...will activate this popup menu
        validate();                     // Draw the applet as soon as possible
                                        // ..although it will not be ready for a while
                                        // That will make it look as if it is fast!
        final Applet a = this;          // used for inner anonymous classes
                                        
        // Clicking on the button should open the popup menu

        b.addActionListener( new ActionListener(){
                public void actionPerformed(ActionEvent e){
                    Rectangle r = b.getBounds();
                    m.show(a, r.x, r.y+r.height); 
                }
       });

       // Load the menu items from the bookmark file

       getParameters();

        try{
        MenuLoader loader = new MenuLoader(              // create new menu loader...
                m                                        // .. to load this menu... 
            ,   getBookmarksReader(filename)             // .. from this file 
            ,   new ActionListener(){                    // Notify this listener when a menu clicked
                    public void actionPerformed(ActionEvent e) {
                        try{  
                            URL url = new URL(e.getActionCommand());    // the menu's action command stores URL 
                            a.getAppletContext().showDocument(url,target);    // load the URL to the target browser window
                        }catch(MalformedURLException me){
                            showStatus("Malformed URL: "+e.getActionCommand());
                        }
                    }
                }
            );
        
        loader.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                if( e.getActionCommand().equals("done") )
                        b.setLabel("Bookmarks");
                else    b.setLabel("Error");
            }
        });
        loader.start();
        }catch(IOException e){
            showStatus("IOException:"+e);
            b.setLabel("Loading Error");
            b.setEnabled(false);
        }
    }

    /* This method can be called from a JavaScript to 
     *  specify target window for opening bookmarks
     */
    public void setTarget(String target){
        this.target = target;
    }


    // ---------------- protected methods ---------------

    Reader getBookmarksReader(String filename) throws IOException{
        return new InputStreamReader( 
                    new URL(getDocumentBase(), filename)
                        .openStream()
        );
    }

    void getParameters(){
        String t = getParameter("target");
        if( t != null ) target = t;
        
        t = getParameter("filename");
        if( t!= null ) filename = t;
    }


    // ---------------- methods for testing ----------------

    void debug(String msg){ System.out.println(msg); }    

    /*
    public URL getDocumentBase(){
        try{
            return new URL("file:.");
        }catch(MalformedURLException e){
            showStatus("MalformedURLException:"+e);
            return null;
        }
    }

    public void showStatus(String status){System.out.println(status);}

    public static void main(String[] args)
    {
        Frame f = new Frame("Bookmark Tester");
        f.setSize(300,200);
        
        final Applet a = new j1menu();
        f.add(a);
        f.addWindowListener( new WindowListener(){
            public void windowClosed(WindowEvent e)  {}
            public void windowClosing(WindowEvent e) {  System.exit(0); }
            public void windowActivated(WindowEvent e)  {}
            public void windowDeactivated(WindowEvent e){}
            public void windowIconified(WindowEvent e)  { a.stop(); }
            public void windowDeiconified(WindowEvent e){ a.start(); }
            public void windowOpened(WindowEvent e) {  a.init(); a.start();}
        });
        f.show();
    }

    */
}
